<?php
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class WebplayerModelCategory extends JModel {

	var $data = array();
	
    function __construct() {
		parent::__construct();
    }
	
	function getdata() {
		$mainframe  = JFactory::getApplication();	
		$option     = JRequest::getCmd('option');
		$task       = JRequest::getCmd('task');
		 
		$limit      = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest($option.$task.'.limitstart', 'limitstart', 0, 'int');
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		
		$this->buildData($this->getparentid(), $spcr = '');		
		if(!$limit) {
			return $this->data;
		} else {
			return array_slice($this->data, $limitstart, $limit);
		}
	}
	
	function getparentid() {
		$mainframe       = &JFactory::getApplication();
		$option          = JRequest::getCmd('option');
		$task            = JRequest::getCmd('task');
		$filter_category = $mainframe->getUserStateFromRequest($option.$task.'filter_category', 'filter_category', -1, 'int');
		
		if ($filter_category > -1) {
			$db     = &JFactory::getDBO();
			$query  = "SELECT parent FROM #__webplayer_category WHERE id=" . $filter_category;
			$db->setQuery($query);
			$output = $db->loadRow();
			
			return $output[0];
		}
		
		return 0;			
	}
	
	function buildData($parent, $spcr = '') {		 
		$mainframe 	      = &JFactory::getApplication();
		$option           = JRequest::getCmd('option');
		$task             = JRequest::getCmd('task');
		$db               =& JFactory::getDBO();		 
		 
		$filter_state     = $mainframe->getUserStateFromRequest($option.$task.'filter_state', 'filter_state', -1, 'int');
		$filter_category  = $mainframe->getUserStateFromRequest($option.$task.'filter_category', 'filter_category', -1, 'int');
		$search           = $mainframe->getUserStateFromRequest($option.$task.'search', 'search', '', 'string');
		$search           = JString::strtolower($search);
		$setparent        = 1;
		 
		$query            = "SELECT * FROM #__webplayer_category";	
				
		$where            = array();		 
				 
		if ($filter_state > - 1) {
			$where[]      = "published={$filter_state}";
			$setparent    = 0;			
		}
		
		if ($filter_category > -1) {
			$tree        = $this->getCategoryTree( $filter_category );
	    	$where[]     = 'id IN ('.implode(',', $tree).')';
		 }
		 
		if ( $search ) {
			$where[]     = 'LOWER(name) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$setparent   = 0;	
		}
		
		if ( $setparent ) {
			$where[]     = "parent=$parent";
		}	

		$where  = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
		 
		$query .= $where;		 
		$query .= " ORDER BY ordering ASC"; 
		 	    
        $db->setQuery( $query );
   		$cats= $db->loadObjectList();
		
		$c = 0;
		$count = count($cats);

        if($count){		
            foreach($cats as $cat){
				$cat->up   = ($c == 0) ? 0 : 1;
                $cat->down = ($c + 1 == $count) ? 0 : 1;
				$cat->spcr = $spcr."<sup>L</sup>&nbsp;&nbsp;";
		
				$this->data[] = $cat;
				$c++;
				if ( $setparent ) {
                	$this->buildData( $cat->id, $spcr."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" );
				}
            }
        }
	}	
	
	function getpagination() {
		 $mainframe  = JFactory::getApplication();	
		 $option     = JRequest::getCmd('option');
		 $task       = JRequest::getCmd('task');
		 
		 $total      = $this->gettotal();
		 $limit      = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		 $limitstart = $mainframe->getUserStateFromRequest($option.$task.'.limitstart', 'limitstart', 0, 'int');
     
    	 jimport( 'joomla.html.pagination' );
		 $pageNav    = new JPagination($total, $limitstart, $limit);
         return($pageNav);
	}
	
	function gettotal() {
		 $mainframe        = JFactory::getApplication();	
		 $option           = JRequest::getCmd('option');
		 $task             = JRequest::getCmd('task');
		 
		 $filter_state     = $mainframe->getUserStateFromRequest($option.$task.'filter_state', 'filter_state', -1, 'int');
		 $filter_category  = $mainframe->getUserStateFromRequest($option.$task.'filter_category', 'filter_category', -1, 'int');
		 $search           = $mainframe->getUserStateFromRequest($option.$task.'search', 'search', '', 'string');
		 $search           = JString::strtolower($search);
		 
         $db               =& JFactory::getDBO();
         $query            = "SELECT COUNT(*) FROM #__webplayer_category";
		 $where            = array();
		 
		 if ($filter_state > -1) {
			$where[]       = "published={$filter_state}";
		 }

		if ($filter_category > -1) {
			$tree          = $this->getCategoryTree( $filter_category );
	    	$where[]       = 'id IN ('.implode(',', $tree).')';
		 }
		 
		 if ( $search ) {
			$where[]       = 'LOWER(name) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		 }

		 $where 		   = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
		 
		 $query           .= $where;

         $db->setQuery( $query );
         $output = $db->loadResult();
         return($output);
	}
	
	function getlists() {
		 $mainframe              = JFactory::getApplication();	
		 $option                 = JRequest::getCmd('option');
		 $task                   = JRequest::getCmd('task');
		 
		 $filter_state           = $mainframe->getUserStateFromRequest($option.$task.'filter_state','filter_state',-1,'int' );
		 $filter_category        = $mainframe->getUserStateFromRequest($option.$task.'filter_category', 'filter_category', -1, 'int');
		 $search                 = $mainframe->getUserStateFromRequest($option.$task.'search','search','','string');
		 $search                 = JString::strtolower ( $search );
     
    	 $lists                  = array ();
		 $lists ['search']       = $search;
            
		 $filter_state_options[] = JHTML::_('select.option', -1, JText::_('- Select Publishing State -'));
		 $filter_state_options[] = JHTML::_('select.option', 1, JText::_('Published'));
		 $filter_state_options[] = JHTML::_('select.option', 0, JText::_('Unpublished'));
		 $lists['state']         = JHTML::_('select.genericlist', $filter_state_options, 'filter_state', 'onchange="this.form.submit();"', 'value', 'text', $filter_state);
		 
		 $category_options[]     = JHTML::_('select.option', -1, JText::_('- Select by Category -'));
		 $categories             = $this->getcategories();
		 foreach ( $categories as $item ) {
			$item->treename      = JString::str_ireplace('&#160;', '-', $item->treename);			
			$category_options[]  = JHTML::_('select.option', $item->id, $item->treename );
		 }
		 $lists['categories']    = JHTML::_('select.genericlist', $category_options, 'filter_category', 'onchange="this.form.submit();"', 'value', 'text', $filter_category);
		 
         return($lists);
	}
	
	function getcategories( $name = '' ) {
        $db     = &JFactory::getDBO();
		$query  = 'SELECT * FROM #__webplayer_category';
		if($name) {
			$query .= ' WHERE name!=' . $db->quote( $name );
		}
		$query .= ' ORDER BY ordering ASC';
		$db->setQuery( $query );
		$mitems = $db->loadObjectList();
		
		$children = array();
		if ( $mitems ) {
			foreach ( $mitems as $v )
			{
				$v->title = $v->name;
				$v->parent_id = $v->parent;
				$pt = $v->parent;				
				$list = @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;
			}
		}
		
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0 );		
		return $list;
	}
	
	function getrow() {
         $db  =& JFactory::getDBO();
         $row =& JTable::getInstance('webplayercategory', 'Table');
         $cid = JRequest::getVar( 'cid', array(0), '', 'array' );
         $id  = $cid[0];
         $row->load($id);
         $lists['published'] = JHTML::_('select.booleanlist','published',$row->published);

         return $row;
	}
	
	function save() {
	  $mainframe = JFactory::getApplication();
	  $row       =& JTable::getInstance('webplayercategory', 'Table');
	  $cid       = JRequest::getVar( 'cid', array(0), '', 'array' );
      $id        = $cid[0];
      $row->load($id);

      if(!$row->bind(JRequest::get('post'))) {
		JError::raiseError(500, $row->getError() );
	  }
	
	  if($row->type == 'Upload') {
	    jimport('joomla.filesystem.file');
		
		if(!JFolder::exists(WEBPLAYER_UPLOAD_BASE)) {
			JFolder::create(WEBPLAYER_UPLOAD_BASE);
		}
		
	  	$row->image = $this->upload('uploadimage');
	  }
	  
	  if(!$row->image && !JRequest::getVar('uploadimage')) {
		$row->image = 'http://img.youtube.com/vi/default.jpg';
	  }
		
	  $row->reorder( "parent=$row->parent" );
	  
	  if(!$row->store()) {
		JError::raiseError(500, $row->getError() );
	  }

	  $task = JRequest::getCmd('task');
	  
	  switch ($task) {
        case 'applycategory':
             $msg  = 'Changes Saved';
             $link = 'index.php?option=com_webplayer&task=editcategory&'. JUtility::getToken() .'=1&'.'cid[]='.$row->id;
             break;
        case 'savecategory':
        default:
              $msg  = 'Saved';
              $link = 'index.php?option=com_webplayer&task=category';
              break;
        }
		
	    $mainframe->redirect($link, $msg);	  
	}
	
	function upload($filename) {
	  $file = @JFile::makeSafe($_FILES[$filename]['name']);
	  $temp = @$_FILES[$filename]['tmp_name'];
	  
      if($file != "") {
     	 if(JFile::upload($temp, WEBPLAYER_UPLOAD_BASE.$file)) {
		 	return WEBPLAYER_UPLOAD_BASEURL.$file;
		 } else {
		 	JError::raiseWarning(21, 'Error Occured While Uploading!');
			return false;
		 }
	  }	
		
	}
	
	function delete() {
	    $mainframe = JFactory::getApplication();
        $cid       = JRequest::getVar( 'cid', array(), '', 'array' );
        $db        =& JFactory::getDBO();
        $cids      = implode( ',', $this->getCategoryTree($cid) );
		
        if(count($cid)) {
            $query = "DELETE FROM #__webplayer_category WHERE id IN ( $cids )";
            $db->setQuery( $query );
            if (!$db->query()) {
                echo "<script> alert('".$db->getErrorMsg()."');window.history.go(-1); </script>\n";
            }
        }
		
        $mainframe->redirect( 'index.php?option=com_webplayer&task=category' );
	}
	
	function cancel() {
	  $mainframe = JFactory::getApplication();
	  $link      = 'index.php?option=com_webplayer&task=category';
	  $mainframe->redirect($link);
	}
	
	function move($inc) {
		$mainframe  = JFactory::getApplication();		
		
    	$row  =& JTable::getInstance('webplayercategory', 'Table');
		$cid  = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$id   = $cid[0];
		$row->load( $id );
		$row->move( $inc, 'parent = '.$row->parent );
		
		$mainframe->redirect( 'index.php?option=com_webplayer&task=category', JText::_('New Ordering Saved') );
    }
	
    function saveorder() {
		$mainframe  = JFactory::getApplication();

		$db	        =& JFactory::getDBO();
		$cid        = JRequest::getVar( 'cid', array(0), '', 'array' );
		$total      = count( $cid );
		$order      = JRequest::getVar( 'order', array(0), '', 'array' );
		JArrayHelper::toInteger($order, array(0));
		 
		$row        =& JTable::getInstance('webplayercategory', 'Table');
		$groupings  = array();
		for( $i=0; $i < $total; $i++ ) {
			$row->load( (int) $cid[$i] );
			$groupings[] = $row->parent;
 			if ($row->ordering != $order[$i]) {
				$row->ordering  = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg() );
				}
			}
		} 
		$groupings = array_unique($groupings);
	
		foreach ($groupings as $group) {
			$row->reorder('parent = "'.$group.'"');
		}
 
		$mainframe->redirect('index.php?option=com_webplayer&task=category', JText::_('New Ordering Saved !'));                
    }
	
	function getCategoryTree( $ids ) {
		$db     = &JFactory::getDBO();			
		$ids    = (array) $ids;
		JArrayHelper::toInteger($ids);
		$catid  = array_unique($ids);
		sort($ids);
		
		$array  = $ids;				
		while(count($array)) {
			$query = "SELECT id FROM #__webplayer_category WHERE parent IN (".implode(',', $array).") AND id NOT IN (".implode(',', $array).")";
			$db->setQuery($query);
			$array = $db->loadResultArray();
			$ids = array_merge($ids, $array);
		}
		JArrayHelper::toInteger($ids);
		$ids = array_unique($ids);			
			
		return $ids;
	}
	
}

?>